      subroutine realtocomplx(hkl_max, first_iq, last_iq, interpolants,
     +     f_hkl)

C     Constructs complex array f_hkl from components of interpolants
C     array.

      implicit none

      integer, intent(in) :: hkl_max, first_iq, last_iq

      double precision, intent(in) :: interpolants(3, 
     +             -hkl_max:hkl_max, -hkl_max:hkl_max,first_iq:last_iq)

      complex, intent(out) :: f_hkl(-hkl_max:hkl_max, -hkl_max:hkl_max,
     +               first_iq:last_iq)

      integer  il, ik, ih
      
      do il = first_iq, last_iq
         do ik = -hkl_max, hkl_max
            do ih = -hkl_max, hkl_max
               if (interpolants(1,ih,ik,il) > 0.0) then
                  f_hkl(ih,ik,il) =
     +                 cmplx(interpolants(2,ih,ik,il)/
     +                 interpolants(1,ih,ik,il),
     +                 interpolants(3,ih,ik,il)/
     +                 interpolants(1,ih,ik,il))
               else 
                  f_hkl(ih,ik,il) = (0.0, 0.0)
               endif
            enddo
         enddo
      enddo
      
      return
      end subroutine realtocomplx
