      subroutine read_1_pif(id, npix_row, npix_col, pix_file_unit,
     $     biggest)

C     Read in a pixel frame and calculate pixel statistics. Currently
C     returns the standard deviation in pixel intensities, but code in
C     place to calculate average and range of pixel intensities.

      implicit none
      INCLUDE '../include/pifhead.inc'
      type (PIFHEAD_T) MAPHEAD, IMGHEAD
      COMMON /PIFHEAD/ MAPHEAD, IMGHEAD

      integer, intent(in) :: id, npix_row, npix_col, pix_file_unit
      real, intent(out)   :: biggest

      double precision favg, fstd, sum, sum2
      real fmax, fmin, pixels(npix_row, npix_col)
      integer count, itemp, ix, iy

      itemp  = npix_row*npix_col
      IMGHEAD%luNum = pix_file_unit
      CALL PIF_READ_GH (IMGHEAD)

      IMGHEAD%IMGNUM = id
      CALL PIF_READ_DH(IMGHEAD)

      call rpifimag_f(itemp, pixels)
  
      fmax      = pixels((npix_col+1)/2,(npix_col+1)/2)
      fmin      = pixels((npix_col+1)/2,(npix_col+1)/2)
      sum       = 0.0
      sum2      = 0.0
      count     = 0

      do iy = 1,npix_row 
         do ix = 1,npix_col 
            if ((ix-(npix_col+1)/2)**2+(iy-(npix_row+1)/2)**2 
     +           <= npix_col**2) then
               sum  = sum  + pixels(ix,iy)
               sum2 = sum2 + pixels(ix,iy)**2
               if (pixels(ix,iy) > fmax) fmax = pixels(ix,iy)
               if (pixels(ix,iy) < fmin) fmin = pixels(ix,iy)
               count = count + 1
            endif
         enddo
      enddo

C     Assign the standard deviation in the pixels to biggest. In
C     previous versions of the routine, commented code indicates that
C     the average pixel intensity and the range in pixel intensities may
C     have been used.

      if (count > 0) then
         favg = sum/count
         fstd = sqrt(abs(sum2/count - favg*favg))
         biggest = fstd
      else
         biggest= 1
      endif
      
      return
      end subroutine read_1_pif
